<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/main.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">main.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="main_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;automate.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="main_8c.html#abf9e6b7e6f15df4b525a2e7705ba3089">   24</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="main_8c.html#abf9e6b7e6f15df4b525a2e7705ba3089">main</a>(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> <span class="keyword">const</span> *argv[]) {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="comment">// Vérifiation que l&#39;utilisateur à bien donné un seul argument (le fichier de configuration)</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;  <span class="keywordflow">if</span>( argc != 2 ){</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    fprintf(stderr, <span class="stringliteral">&quot;Nombre d&#39;argument invalide.&quot;</span>);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  }</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    srand(time(NULL)); <span class="comment">// Pour l&#39;initialisation aléatoire</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;  ptr_str_fc f_config = <a class="code" href="fichier__configuration_8c.html#ad80bfd5b28d3fc81e66d83fa23690e88">creer_fichier_configuration</a>( argv[1] ); <span class="comment">// fichier de configuration</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  ptr_automate automate = <a class="code" href="automate_8c.html#a117ebb3a717f9bbd035e7b295dcf26cb">creer_automate</a>(f_config); <span class="comment">// automate</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;  <a class="code" href="automate_8c.html#aa3e1c93736b3bc4efedcb6a9846b1889">evoluer</a>( automate ); <span class="comment">// évolution de l&#39;automate</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  <span class="comment">// Si le programme crée une image PGM</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keywordflow">if</span> (<a class="code" href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a>(f_config) == 1){</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a>(automate, &amp;<a class="code" href="automate_8c.html#a320cea72ddfeeb38cef103fff39e31b4">_affiche_automate_image</a>);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  }</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="comment">// Si l&#39;on souhaite faire un affichage dans le terminal</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="comment">// Si le nombre d&#39;état et de 2 (0 et 1)</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a>(f_config) == 2){</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a>(automate, &amp;<a class="code" href="automate_8c.html#ab13ad43eea87c41a9a080239a0887a7f">_affiche_automate_terminal_binaire</a>);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  }</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="comment">// Si le nombre d&#39;état est supérieur à 2 (0, 1, 2, 3, ...)</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a>(automate, &amp;<a class="code" href="automate_8c.html#a9fdbceb307999d064bf86f99d3598539">_affiche_automate_terminal_somme</a>);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <a class="code" href="automate_8c.html#aa3ba78ebbf6cec54e6e4e0fa0fced8ee">delete_automate</a>(&amp;automate); <span class="comment">// Désalocation de la mémoire de l&#39;automate</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <a class="code" href="fichier__configuration_8c.html#a8e23c05945f10746ec4182b61123af00">delete_fichier_configuration</a>( f_config ); <span class="comment">// Désalocation mémoire des données de configuration</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="afichier__configuration_8c_html_a0747aaffe60671eda2ba956722a8c191"><div class="ttname"><a href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a></div><div class="ttdeci">bool get_enregistrer_image(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;enregistrer_image&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00156">fichier_configuration.c:156</a></div></div>
<div class="ttc" id="aautomate_8c_html_a5739d8a1c873eea2c0a1099cc20ea7ef"><div class="ttname"><a href="automate_8c.html#a5739d8a1c873eea2c0a1099cc20ea7ef">affiche_automate</a></div><div class="ttdeci">void affiche_automate(ptr_automate automate, void(*_affiche)(ptr_automate))</div><div class="ttdoc">Fonction generique permettant d'afficher differemment l'automate.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00251">automate.c:251</a></div></div>
<div class="ttc" id="aautomate_8c_html_a9fdbceb307999d064bf86f99d3598539"><div class="ttname"><a href="automate_8c.html#a9fdbceb307999d064bf86f99d3598539">_affiche_automate_terminal_somme</a></div><div class="ttdeci">void _affiche_automate_terminal_somme(ptr_automate automate)</div><div class="ttdoc">Affiche les attributs de la structure automate_cell.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00166">automate.c:166</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afef69ee54144409041ea66d6e1185312"><div class="ttname"><a href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a></div><div class="ttdeci">unsigned int get_nb_etat(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00100">fichier_configuration.c:100</a></div></div>
<div class="ttc" id="aautomate_8c_html_a117ebb3a717f9bbd035e7b295dcf26cb"><div class="ttname"><a href="automate_8c.html#a117ebb3a717f9bbd035e7b295dcf26cb">creer_automate</a></div><div class="ttdeci">ptr_automate creer_automate(ptr_str_fc f_config)</div><div class="ttdoc">Créer un automate appartir des dnnées de configuration (structure fichier_configuration)</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00048">automate.c:48</a></div></div>
<div class="ttc" id="amain_8c_html_abf9e6b7e6f15df4b525a2e7705ba3089"><div class="ttname"><a href="main_8c.html#abf9e6b7e6f15df4b525a2e7705ba3089">main</a></div><div class="ttdeci">int main(int argc, char const *argv[])</div><div class="ttdoc">Le programme principale (l'exécutable)</div><div class="ttdef"><b>Definition:</b> <a href="main_8c_source.html#l00024">main.c:24</a></div></div>
<div class="ttc" id="aautomate_8c_html_ab13ad43eea87c41a9a080239a0887a7f"><div class="ttname"><a href="automate_8c.html#ab13ad43eea87c41a9a080239a0887a7f">_affiche_automate_terminal_binaire</a></div><div class="ttdeci">void _affiche_automate_terminal_binaire(ptr_automate automate)</div><div class="ttdoc">Fonction générique perrmettant d'afficher dans le terminal avec des symboles (ex: X,...</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00225">automate.c:225</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_ad80bfd5b28d3fc81e66d83fa23690e88"><div class="ttname"><a href="fichier__configuration_8c.html#ad80bfd5b28d3fc81e66d83fa23690e88">creer_fichier_configuration</a></div><div class="ttdeci">ptr_str_fc creer_fichier_configuration(const char *nom_fichier)</div><div class="ttdoc">Créer un pointeur de pointeur de structure fichier_configuration à partir du nom du fichier que l'éxe...</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00054">fichier_configuration.c:54</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a8e23c05945f10746ec4182b61123af00"><div class="ttname"><a href="fichier__configuration_8c.html#a8e23c05945f10746ec4182b61123af00">delete_fichier_configuration</a></div><div class="ttdeci">void delete_fichier_configuration(ptr_str_fc f_config)</div><div class="ttdoc">Déalou la mémoire utilisé par la structure fichier_configuration ainsi que ses attributs.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00399">fichier_configuration.c:399</a></div></div>
<div class="ttc" id="aautomate_8c_html_aa3ba78ebbf6cec54e6e4e0fa0fced8ee"><div class="ttname"><a href="automate_8c.html#aa3ba78ebbf6cec54e6e4e0fa0fced8ee">delete_automate</a></div><div class="ttdeci">void delete_automate(ptr_automate *ptr)</div><div class="ttdoc">Désaloue la mémoire des attributs de la structure automate_cell, la structure elle même et son pointe...</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00147">automate.c:147</a></div></div>
<div class="ttc" id="aautomate_8c_html_aa3e1c93736b3bc4efedcb6a9846b1889"><div class="ttname"><a href="automate_8c.html#aa3e1c93736b3bc4efedcb6a9846b1889">evoluer</a></div><div class="ttdeci">void evoluer(ptr_automate automate)</div><div class="ttdoc">Faire évoluer les ceellules de l'automate appartir d'une règle.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00092">automate.c:92</a></div></div>
<div class="ttc" id="aautomate_8c_html_a320cea72ddfeeb38cef103fff39e31b4"><div class="ttname"><a href="automate_8c.html#a320cea72ddfeeb38cef103fff39e31b4">_affiche_automate_image</a></div><div class="ttdeci">void _affiche_automate_image(ptr_automate automate)</div><div class="ttdoc">Crée une mage PGM, stock le résultat de l'automate et enregistre l'image.</div><div class="ttdef"><b>Definition:</b> <a href="automate_8c_source.html#l00189">automate.c:189</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
